%define srdsjavadir %{_datadir}/srds

Name:		srds
Version:	0.3.12
Release:	%mkrel 1
URL:		http://www.xtreemos.org/
Group:		System/Cluster
License:	GPL
Source0:	srds-%{version}.tar.bz2
#Patch0:		build.xml.patch
BuildRequires:	xtreemrss
BuildRequires:	junit java-devel >= 1.6.0 ant
BuildRequires:	log4j xvoms dixi-main eXist
BuildRequires:	xmlrpc3-client ws-commons-util scalaris-java scalaris jakarta-commons-cli servlet
Requires:	java >= 1.6.0
Requires:	xtreemrss
Requires:	xmlrpc3-client ws-commons-util
Requires:	log4j xvoms dixi-main dixi-vom-rca-server dixi-xati
Requires:	jakarta-commons-collections jakarta-commons-logging classpathx-mail antlr asm
Requires:	jmock1 dom4j geronimo-jta-1.0.1B-api cglib jakarta-commons-cli
Requires:	servlet
Requires:	xtreemrss
Requires:	srds-jardeps = %{version}-%{release}
Requires:	scalaris-java scalaris
Requires:	eXist gson
Summary:	SRDS Service/Resource Discovery Service
Source1:	clink170.jar
Source2:	jetty-6.1.20.jar
Source3:	OtpErlang-1.4.2.jar
Source4:	je-4.0.103.jar
Source5:	mail.jar
Source6:	jetty-util-7.1.6.v20100715.jar
Source7:	overlayweaver-0.9.11-mod1.2.jar
Source8:	jetty-continuation-7.1.6.v20100715.jar
Source9:	jetty-http-7.1.6.v20100715.jar
Source10:	jetty-io-7.1.6.v20100715.jar
Source11:	jetty-security-7.1.6.v20100715.jar
Source12:	jetty-servlet-7.1.6.v20100715.jar
Source13:	jetty-server-7.1.6.v20100715.jar

BuildArch:	noarch
%description
The SRDS (Service/Resource Discovery Service) provides several types
of directory services to other modules of XtreemOS. Different
interfaces ans set of functionalities are defined for each client.
This first release providies to the AEM module the Resource Location
Service and the Job Directory Service. They respectively return a list
of computing resources matching a specific resoruce query (JSDL), and
allow to manage job information in a decentralized manner.

Each node within XtreemOS has to run an instance of SRDS, the
instances creating a few overlay networks (currently, 2).

Dynamically changing information is stored into one or more
Distributed HashTables (DHT) by the SRDS; this version of SRDS
exploits ADS_Bamboo, a custom version of the Bamboo DHT. SRDS depends
on the ADS_Bamboo package. The DHT(s) is (are) run and initialized by
the SRDS through a script, who controls the bamboo configuration.

Static information about computing resources is retrieved through the
RSS module. The RSS package is an independent module, but it is called
by the SRDS. SRDS and RSS depend on each one another.

%package jardeps
Summary:	srds dependencies
Group:		System/Cluster
%description jardeps
Dependencies for SRDS.

%prep
%setup -q
#%patch0 -p0

cp -p %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} %{SOURCE5}  %{SOURCE6} %{SOURCE7} %{SOURCE8} %{SOURCE9} %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} lib/

cd lib
for jarfile in aem-node.jar aem-server.jar DIXIMain.jar DIXIMainServices.jar \
	xati.jar xtreemrss.jar log4j-1.2.14.jar scalaris/scalaris.jar xstream.jar \
	javamail.jar 
do
   ln -s %{_javadir}/$jarfile .
done

ln -s %{_javadir}/ws-commons-util.jar ws-commons-util-1.0.2.jar
ln -s %{_javadir}/junit4.jar junit-4.5.jar

for jarfile in xmlrpc-common.jar xmlrpc-server.jar xmlrpc-client.jar
do
ln -s %{_javadir}/eXist/$jarfile .
done

%build
ant clean
ant
ant build-jar

%install
%{__rm} -Rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/xos/config
%{__mkdir_p} %{buildroot}%{srdsjavadir}

cp -a config/Ads config/OW config/Schemas %{buildroot}%{_sysconfdir}/xos/config/
cp %name.jar %{buildroot}/%{_javadir}/

pushd lib
# remove xmlrpc, and other XOS jars
rm -rf xmlrpc-* DIXIMain* aem* junit* log4j* scalaris* xati* xstream* xtreemrss* ws-common* javamail*
cp -a *.jar %{buildroot}%{srdsjavadir}/
popd

%post
pushd %{_javadir}
for jarfile in xmlrpc-common.jar xmlrpc-server.jar xmlrpc-client.jar
do
ln -s %{_javadir}/eXist/$jarfile .
done
popd


%clean
%{__rm} -Rf %{buildroot}

%files
%doc README AUTHORS INSTALL DEPENDENCIES
%defattr(-,root,root)
%{_javadir}/%name.jar
%config(noreplace) %{_sysconfdir}/xos/config/Ads/*
%config(noreplace) %{_sysconfdir}/xos/config/OW/OWconfig.cfg
#%config(noreplace) %{_sysconfdir}/xos/config/OW/owlogging.properties
%config(noreplace) %{_sysconfdir}/xos/config/OW/runow.sh
%config(noreplace) %{_sysconfdir}/xos/config/OW/stopow.sh
%config(noreplace) %{_sysconfdir}/xos/config/Schemas/*

%files jardeps
%defattr(-,root,root)
%{srdsjavadir}/OtpErlang-*.jar
%{srdsjavadir}/clink170.jar
%{srdsjavadir}/je-*.jar
%{srdsjavadir}/jetty-*
%{srdsjavadir}/mail.jar
%{srdsjavadir}/jetty-util-*.jar
%{srdsjavadir}/overlayweaver-*.jar
